format ELF64

; Read a string of maximum length (defined by input format)
macro readstring text, string, fmt {
local ..txt, ..fmt, ..code, ..next, ..continue, ..done
        jmp      ..code
  ..txt db       text, 00h
  ..fmt db       fmt, 00h
  ..code:
        mov      rcx, ..txt
        call     printf
        mov      rcx, ..fmt
        mov      rdx, string
        call     scanf
        ; Convert '_' to space
        mov      rdi, string
  ..next:
        mov      al, [rdi]
        cmp      al, 00h
        je       ..done
        cmp      al, '_'
        jne       ..continue
        mov      byte [rdi], ' '
  ..continue:
        inc      rdi
        jmp      ..next
  ..done:
}

; Read a string of maximum length
macro str_read text, string, maxlen {
        readstring `text, string, "%"#maxlen#"s"
}

; Print a string
macro str_write string {
        mov      rcx, string
        call     printf
}

; Print a string with new line
macro str_writeln string {
        str_write string
        newline
}

; Print a new line
macro newline {
local ..str, ..code
        jmp      ..code
  ..str db       0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..str
        call     printf
}

; Convert a string to uppercase
macro uppercase string {
local ..next, ..continue, ..done
        mov      rsi, string
        mov      rdi, rsi
  ..next:
        lodsb
        cmp     al, 00h
        je      ..done
        cmp     al, 'a'
        jl      ..continue
        cmp     al, 'z'
        jg      ..continue
        sub     al, 32
  ..continue:
        stosb
        jmp     ..next
  ..done:
}

; Convert a string to lowercase
macro lowercase string {
local ..next, ..continue, ..done
        mov      rsi, string
        mov      rdi, rsi
  ..next:
        lodsb
        cmp     al, 00h
        je      ..done
        cmp     al, 'A'
        jl      ..continue
        cmp     al, 'Z'
        jg      ..continue
        add     al, 32
  ..continue:
        stosb
        jmp     ..next
  ..done:
}

section '.bss' writeable
string  db       101 dup (?)

section ".text" executable
public main
extrn printf
extrn scanf
main:
        mov      rbp, rsp;
        sub      rsp, 32
        and      rsp, -16
        str_read "Please enter a string? ", string, "100"
        str_writeln string
        uppercase string
        str_writeln string
        lowercase string
        str_writeln string
        mov      rsp, rbp
        xor      rax, rax
        ret
