format ELF64

macro print_int integer {
local ..fmt, ..code
        jmp      ..code
  ..fmt db       '%u', 0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..fmt
        mov      rdx, integer
        call     printf
}

macro print_literal string {
local ..str, ..code
        jmp      ..code
  ..str db       string
        db       00h
  ..code:
        mov      rcx, ..str
        call     printf
}

section '.data' writeable
frmat   db      '%u', 00h
number  dq      ?
save    dq      ?

section '.text' executable
public main
extrn printf
extrn scanf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        print_literal "Please, enter an integer number from 1 to 20? "
        mov     rcx, frmat
        mov     rdx, number
        call    scanf
        mov     rax, [number]
        cmp     rax, 1
        jl      invalid
        cmp     rax, 20
        jg      invalid
        mov     rbx, rax
next:
        dec     rbx
        cmp     rbx, 0
        je      done
        mul     rbx
        jmp     next
done:
        mov     [save], rax
        print_literal "The factorial of this number is "
        mov     rax, [save]
        print_int rax
        jmp     exit
invalid:
        print_literal <"Error: Number out of range!", 0Dh, 0Ah>
exit:
        mov     rsp, rbp
        xor     rax, rax
        ret
