format ELF64

; Read a string of maximum length (defined by input format)
macro str_read text, string, fmt {
local ..txt, ..fmt, ..code
        jmp      ..code
  ..txt db       text, 00h
  ..fmt db       fmt, 00h
  ..code:
        mov      rcx, ..txt
        call     printf
        mov      rcx, ..fmt
        mov      rdx, string
        call     scanf
}

; Print a string
macro str_write string {
local ..continue
    if string eqtype 'string'
        call ..continue
        db       string, 00h
      ..continue:
        pop      rcx
        call     printf
    else if string eqtype ..continue
        mov      rcx, string
        call     printf
    end if
}

; Print a string with new line
macro str_writeln string {
        str_write string
        newline
}

; Print a new line
macro newline {
local ..str, ..code
        jmp      ..code
  ..str db       0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..str
        call     printf
}

section '.bss' writeable
uname   db       26 dup (?)

section ".text" executable
public main
extrn printf
extrn scanf
main:
        mov      rbp, rsp;
        sub      rsp, 32
        and      rsp, -16
        str_read "Please enter your name? ", uname, "%25s"
        str_write 'Hello, '
        str_write uname
        str_writeln '! How are you?'
        mov      rsp, rbp
        xor      rax, rax
        ret
