format ELF64

; Fill array with byte numbers from M to N

macro fill_array array, max, first, last {
        mov      rdi, array
        repeat last - first + 1
          if % > max
            break
          end if
          mov    byte [rdi+%-1], first + % - 1
        end repeat
}

; Print array of bytes

macro print_array array, len {
local ..fmt, ..eol, ..code
        jmp      ..code
  ..fmt db       '%5u ', 00h
  ..eol db       0Dh, 0Ah, 00h
  ..code:
        i = 1
        while i <= len
          mov    rcx, ..fmt
          mov    rdi, array
          xor    rdx, rdx
          mov    dl, [rdi+i-1]
          call   printf
          i = i + 1
        end while
        mov      rcx, ..eol
        call     printf
}

section '.bss' writeable
array   db 10 dup (?)

section '.text' executable
public main
extrn printf
extrn scanf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        fill_array array, 10, 1, 5
        print_array array, 5
        fill_array array, 10, 20, 30
        print_array array, 10
        mov     rsp, rbp
        xor     rax, rax
        ret
