format ELF64

struc rectangle x1, y1, x2, y2 {
  .x1   dw       x1
  .y1   dw       y1
  .x2   dw       x2
  .y2   dw       y2
}

macro print_int integer {
local ..fmt, ..code
        jmp      ..code
  ..fmt db       '%u', 0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..fmt
        xor      rdx, rdx
        mov      dx, integer
        call     printf
}

macro print_literal string {
local ..str, ..code
        jmp      ..code
  ..str db       string
        db       00h
  ..code:
        mov      rcx, ..str
        call     printf
}

section '.data' writeable
rect1   rectangle 0, 0, 25, 4
rect2   rectangle ?, ?, ?, ?

section '.text' executable
public main
extrn printf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        print_literal "The surface of rectangle 1 is "
        mov     ax, [rect1.x2]
        sub     ax, [rect1.x1]
        mov     bx, [rect1.y2]
        sub     bx, [rect1.y1]
        imul    bx
        print_int ax
        mov     [rect2.x1], 10
        mov     [rect2.y1], 20
        mov     [rect2.x2], 60
        mov     [rect2.y2], 25
        print_literal "The surface of rectangle 2 is "
        mov     ax, [rect2.x2]
        sub     ax, [rect2.x1]
        mov     bx, [rect2.y2]
        sub     bx, [rect2.y1]
        imul    bx
        print_int ax
        mov     rsp, rbp
        xor     rax, rax
        ret
