format ELF64

struc rectangle x1, y1, x2, y2 {
  .x1   dw       x1
  .y1   dw       y1
  .x2   dw       x2
  .y2   dw       y2
}

macro print_int integer {
local ..fmt, ..code
        jmp      ..code
  ..fmt db       '%u', 0Dh, 0Ah, 00h
  ..code:
        mov      rcx, ..fmt
        xor      rdx, rdx
        mov      dx, integer
        call     printf
}

macro print_literal string {
local ..str, ..code
        jmp      ..code
  ..str db       string
        db       00h
  ..code:
        mov      rcx, ..str
        call     printf
}

macro rect_surface x1, y1, x2, y2 {
        mov     ax, x2
        sub     ax, x1
        mov     bx, y2
        sub     bx, y1
        imul    bx
}

section '.data' writeable
rect1   rectangle 0, 0, 25, 4
rect2   rectangle 10, 20, 60, 25

section '.text' executable
public main
extrn printf
main:
        mov     rbp, rsp
        sub     rsp, 32
        and     rsp, -16
        print_literal "The surface of rectangle 1 is "
        rect_surface [rect1.x1], [rect1.y1], [rect1.x2], [rect1.y2]
        print_int ax
        print_literal "The surface of rectangle 2 is "
        rect_surface [rect2.x1], [rect2.y1], [rect2.x2], [rect2.y2]
        print_int ax
        mov     rsp, rbp
        xor     rax, rax
        ret
